Scriptname TissHeadTrackMCM extends SKI_ConfigBase

globalvariable property Key_Camera auto
globalvariable property Key_Pause auto
globalvariable property Key_Ecran auto
globalvariable property Key_Switch auto

globalvariable property CameraComplet auto
globalvariable property Camera180 auto
globalvariable property CameraHybride auto

globalvariable property EcranComplet auto
globalvariable property Ecran180 auto
globalvariable property EcranHybride auto

globalvariable property DisableWeapon auto
globalvariable property DisableNotifications auto
globalvariable property Invert360 auto
globalvariable property AutoDialogue auto

TissHeadTrack property TissHeadTrackQuest auto

Int optionKeySwitch = 0
Int optionExpressionId
Int optionExpressionValue

Int optionIsMoveCamera
Int optionMoveCamX
Int optionMoveCamY
Int optionMoveCamZ
; Int optionIsLongMoveCamera
Int optionLongMoveCamX
Int optionLongMoveCamY
Int optionLongMoveCamZ
Int optionReadExpression
Int optionIsSetExpression

Int optionInAngle
Int optionOutAngle
Int optionReset

Int initExpressionId
Int[] initPhonemes
Int[] initModifiers

Int[] optionPhonemes
Int[] optionModifiers
Int[] noneArray

Event OnConfigOpen_____() ; fjdsiojfjosdijiodfjiosdjiosfjdiojniosdfsdfjio OnConfigOpen is CALLED AFTER OnPageReset!!!!!!!!!!!FUCKKKKKKKKKK
    ; Debug.Trace("onconfigopen1")
    ;save current expression first


    
    TissHeadTrackQuest.StopLookCam()
    ; Debug.Trace("onconfigopen2:"+initPhonemes.Length+"|"+initModifiers.Length+"|"+optionPhonemes.Length+"|"+optionModifiers.Length)
EndEvent
event OnConfigClose()
    initPhonemes=noneArray
    initModifiers=noneArray
    optionPhonemes=noneArray
    optionModifiers=noneArray
endevent

function OnPageReset(String page)
	SetCursorFillMode(TOP_TO_BOTTOM)
	SetCursorPosition(1)
	optionReset = self.AddTextOption("Reset/Uninstall", "", 0)

	SetCursorPosition(0)

	optionKeySwitch = AddKeyMapOption("Toggle Key", Key_Switch.GetValue() as Int, 0)
	self.AddHeaderOption("Move Camera?", 0)
	optionIsMoveCamera = self.AddToggleOption("Move Camera?", TissHeadTrackQuest.IsMoveCamera, 0)
    optionMoveCamX = self.AddSliderOption("Move Camera X", TissHeadTrackQuest.MoveCamX, "{0}", 0)
    optionMoveCamZ = self.AddSliderOption("Move Camera Y", TissHeadTrackQuest.MoveCamZ, "{0}", 0)
    optionMoveCamY = self.AddSliderOption("Move Camera Zoom (0 disable)", TissHeadTrackQuest.MoveCamY, "{0}", 0)
    
	; optionIsLongMoveCamera = self.AddToggleOption("Also Move Camera on Scroll?", TissHeadTrackQuest.IsLongMoveCamera, 0)
    self.AddTextOption("Long Press Setup", "", self.OPTION_FLAG_DISABLED)
    optionLongMoveCamX = self.AddSliderOption("Camera X - Long Press", TissHeadTrackQuest.LongMoveCamX, "{0}", 0)
    optionLongMoveCamZ = self.AddSliderOption("Camera Y - Long Press", TissHeadTrackQuest.LongMoveCamZ, "{0}", 0)
    optionLongMoveCamY = self.AddSliderOption("Camera Zoom - Long Press", TissHeadTrackQuest.LongMoveCamY, "{0}", 0)

	self.AddHeaderOption("Angle", 0)
    optionInAngle = self.AddSliderOption("Start Anlge Limit", TissHeadTrackQuest.InAngle, "{0}", 0)
    optionOutAngle = self.AddSliderOption("Stop Angle Limit", TissHeadTrackQuest.OutAngle, "{0}", 0)

	self.AddHeaderOption("Expression", 0)
	optionIsSetExpression = self.AddToggleOption("Change Expression?", TissHeadTrackQuest.IsSetExpression, 0)
	optionReadExpression = self.AddTextOption("Read Current Expression", "", 0)
    optionExpressionId = self.AddSliderOption("Expression Id", TissHeadTrackQuest.ExpressionId, "{0}", 0)
    optionExpressionValue = self.AddSliderOption("Expression Value", TissHeadTrackQuest.ExpressionValue, "{0}", 0)

    ; Debug.Trace("OnPageReset:"+initPhonemes.Length+"|"+initModifiers.Length+"|"+optionPhonemes.Length+"|"+optionModifiers.Length)
    if TissHeadTrackQuest.Phonemes.Length==0
        TissHeadTrackQuest.Phonemes=new Int[16]
    endif
    if TissHeadTrackQuest.Modifiers.Length==0
        TissHeadTrackQuest.Modifiers=new Int[14]
    endif

    
    if initPhonemes.Length==0
        initPhonemes=new Int[16] ;0~15
        initModifiers=new Int[14] ;0~13
        optionPhonemes=new Int[16] ;0~15
        optionModifiers=new Int[14] ;0~13
        Actor PlayerRef = TissHeadTrackQuest.PlayerRef
        
        initExpressionId=MfgConsoleFunc.GetExpressionID(PlayerRef)
        int i = 0
        while i < 16
            initPhonemes[i]=MfgConsoleFunc.GetPhoneme(PlayerRef,i)
            i+=1
        endWhile
        i = 0
        while i < 14
            initModifiers[i]=MfgConsoleFunc.GetModifier(PlayerRef,i)
            i+=1
        endWhile
    endif

    ; Debug.Trace(TissHeadTrackQuest.Phonemes)

    int i = 0
    while i < 16
        optionPhonemes[i] = self.AddSliderOption("Phoneme "+i, TissHeadTrackQuest.Phonemes[i], "{0}", 0)
        i+=1
    endWhile
    i = 0
    while i < 14
        optionModifiers[i] = self.AddSliderOption("Modifier "+i, TissHeadTrackQuest.Modifiers[i], "{0}", 0)
        i+=1
    endWhile
endFunction

function OnOptionSelect(Int option)
    if option == optionIsMoveCamera
        TissHeadTrackQuest.IsMoveCamera=!TissHeadTrackQuest.IsMoveCamera
        self.SetToggleOptionValue(option, TissHeadTrackQuest.IsMoveCamera, false)
    ; elseif option == optionIsLongMoveCamera
    ;     TissHeadTrackQuest.IsLongMoveCamera=!TissHeadTrackQuest.IsLongMoveCamera
    ;     bool xxx=TissHeadTrackQuest.IsLongMoveCamera
    ;     self.SetToggleOptionValue(option, xxx, false)
    elseif option == optionReset
        TissHeadTrackQuest.Reset()
    elseif option == optionReadExpression
        TissHeadTrackQuest.ExpressionId = initExpressionId
        self.SetSliderOptionValue(optionExpressionId, TissHeadTrackQuest.ExpressionId, "{0}", false)

        
        int i = 0
        while i < 16
            TissHeadTrackQuest.Phonemes[i]=initPhonemes[i]
            self.SetSliderOptionValue(optionPhonemes[i], TissHeadTrackQuest.Phonemes[i] as Float, "{0}", false)
            i+=1
        endWhile
        i = 0
        while i < 14
            TissHeadTrackQuest.Modifiers[i]=initModifiers[i]
            self.SetSliderOptionValue(optionModifiers[i], TissHeadTrackQuest.Modifiers[i] as Float, "{0}", false)
            i+=1
        endWhile
    elseif option == optionIsSetExpression
        TissHeadTrackQuest.IsSetExpression=!TissHeadTrackQuest.IsSetExpression
        self.SetToggleOptionValue(option, TissHeadTrackQuest.IsSetExpression, false)
    endif 
endfunction

function OnOptionSliderOpen(Int option)
    if option == optionExpressionId
		self.SetSliderDialogStartValue(TissHeadTrackQuest.ExpressionId)
		self.SetSliderDialogRange(0.0, 20.0)
		self.SetSliderDialogDefaultValue(-1.0)
		self.SetSliderDialogInterval(1.0)
    elseif option == optionExpressionValue
		self.SetSliderDialogStartValue(TissHeadTrackQuest.ExpressionValue)
		self.SetSliderDialogRange(0.0, 256.0)
		self.SetSliderDialogDefaultValue(0.0)
		self.SetSliderDialogInterval(1.0)
    elseif option == optionMoveCamX
		self.SetSliderDialogStartValue(TissHeadTrackQuest.MoveCamX)
		self.SetSliderDialogRange(-100.0, 100.0)
		self.SetSliderDialogDefaultValue(0.0)
		self.SetSliderDialogInterval(1.0)
    elseif option == optionMoveCamY
		self.SetSliderDialogStartValue(TissHeadTrackQuest.MoveCamY)
		self.SetSliderDialogRange(0.0, 1000.0)
		self.SetSliderDialogDefaultValue(0.0)
		self.SetSliderDialogInterval(1.0)
    elseif option == optionMoveCamZ
		self.SetSliderDialogStartValue(TissHeadTrackQuest.MoveCamZ)
		self.SetSliderDialogRange(-100.0, 100.0)
		self.SetSliderDialogDefaultValue(0.0)
		self.SetSliderDialogInterval(1.0)
    elseif option == optionLongMoveCamX
		self.SetSliderDialogStartValue(TissHeadTrackQuest.LongMoveCamX)
		self.SetSliderDialogRange(-100.0, 100.0)
		self.SetSliderDialogDefaultValue(0.0)
		self.SetSliderDialogInterval(1.0)
    elseif option == optionLongMoveCamY
		self.SetSliderDialogStartValue(TissHeadTrackQuest.LongMoveCamY)
		self.SetSliderDialogRange(0, 1000.0)
		self.SetSliderDialogDefaultValue(0.0)
		self.SetSliderDialogInterval(1.0)
    elseif option == optionLongMoveCamZ
		self.SetSliderDialogStartValue(TissHeadTrackQuest.LongMoveCamZ)
		self.SetSliderDialogRange(-100.0, 100.0)
		self.SetSliderDialogDefaultValue(0.0)
		self.SetSliderDialogInterval(1.0)
    elseif option == optionInAngle
		self.SetSliderDialogStartValue(TissHeadTrackQuest.InAngle)
		self.SetSliderDialogRange(0.0, 180.0)
		self.SetSliderDialogDefaultValue(90.0)
		self.SetSliderDialogInterval(10.0)
    elseif option == optionOutAngle
		self.SetSliderDialogStartValue(TissHeadTrackQuest.OutAngle)
		self.SetSliderDialogRange(0.0, 180.0)
		self.SetSliderDialogDefaultValue(90.0)
		self.SetSliderDialogInterval(10.0)
    else 
		self.SetSliderDialogRange(0.0, 256.0)
		self.SetSliderDialogDefaultValue(0.0)
		self.SetSliderDialogInterval(1.0)

        int i = 0
        while i < 16
            if option==optionPhonemes[i]
		        self.SetSliderDialogStartValue(TissHeadTrackQuest.Phonemes[i])
                return
            endif
            i+=1
        endWhile
        i = 0
        while i < 14
            if option==optionModifiers[i]
		        self.SetSliderDialogStartValue(TissHeadTrackQuest.Modifiers[i])
                return
            endif
            i+=1
        endWhile
    endif

endfunction

function OnOptionSliderAccept(Int option, Float a_value)
    self.SetSliderOptionValue(option, a_value, "{0}", false)
    if option == optionExpressionId
        TissHeadTrackQuest.ExpressionId=a_value as Int
    elseif option == optionExpressionValue
        TissHeadTrackQuest.ExpressionValue=a_value as Int
    elseif option == optionMoveCamX
        TissHeadTrackQuest.MoveCamX=a_value as Int
    elseif option == optionMoveCamY
        TissHeadTrackQuest.MoveCamY=a_value as Int
    elseif option == optionMoveCamZ
        TissHeadTrackQuest.MoveCamZ=a_value as Int
    elseif option == optionLongMoveCamX
        TissHeadTrackQuest.LongMoveCamX=a_value as Int
    elseif option == optionLongMoveCamY
        TissHeadTrackQuest.LongMoveCamY=a_value as Int
    elseif option == optionLongMoveCamZ
        TissHeadTrackQuest.LongMoveCamZ=a_value as Int
    elseif option == optionInAngle
        TissHeadTrackQuest.InAngle=a_value as Int
    elseif option == optionOutAngle
        TissHeadTrackQuest.OutAngle=a_value as Int
    else 
    ; Debug.Trace("option:"+option)
    ; Debug.Trace(optionPhonemes)
    ; Debug.Trace(optionModifiers)
        int i = 0
        while i < 16
            if option==optionPhonemes[i]
		        TissHeadTrackQuest.Phonemes[i]=a_value as Int
    ; Debug.Trace(TissHeadTrackQuest.Phonemes)
                return
            endif
            i+=1
        endWhile
        i = 0
        while i < 14
            if option==optionModifiers[i]
		        TissHeadTrackQuest.Modifiers[i]=a_value as Int
    ; Debug.Trace(TissHeadTrackQuest.Phonemes)
                return
            endif
            i+=1
        endWhile
    endif
endfunction

function OnOptionDefault(Int option)
    if option == optionKeySwitch
		Key_Switch.SetValue(42)
		SetKeyMapOptionValue(optionKeySwitch, 42, false)
	endiF
	TissHeadTrackQuest.ReRegisterAllKeys()
endFunction


function OnOptionKeyMapChange(Int option, Int keyCode, String conflictControl, String conflictName)
	bool ok = true
	if conflictControl != ""
		String Avertissement
		if conflictName != ""
			Avertissement = "This key is already mapped to:\n\"" + conflictControl + "\"\n(" + conflictName + ")\n\nAre you sure you want to continue ?"
		else
			Avertissement = "This key is already mapped to:\n\"" + conflictControl + "\"\n\nAre you sure you want to continue ?"
		endIf
		ok = self.ShowMessage(Avertissement, true, "$Yes", "$No")
	endIf

	if ok 
        If option == optionKeySwitch
			Key_Switch.SetValue(keyCode as Int)
			SetKeyMapOptionValue(optionKeySwitch, keyCode, false)
		endIf
	endIf

	TissHeadTrackQuest.ReRegisterAllKeys()
EndFunction
